from app.location_log.models import LocationLogHistory
from app import db
from datetime import datetime, timedelta
import json

def save_location_log_history(device_id, device_name, dt_mac, user_or_patient_name, room,
                                                   site_id, la_time, flag):
    new_log_history = LocationLogHistory(
        site_id=site_id,
        device_id=device_id,
        room_id =room.id,
        location_log_arr=json.dumps({
            "user_patient_name": user_or_patient_name,
            "device_name": device_name,
            "dt_mac": dt_mac,
            "room_name": room.room_name
        }),
        location_timeline_arr=json.dumps([construt_data_new_entry(room.room_name, user_or_patient_name, la_time)]),
        flag=flag
    )
    db.session.add(new_log_history)
    db.session.commit()
def append_location_time_line_array(existing_log, room_name, user_or_patient_name, la_time):
    la_time = check_time_format(la_time)
    location_timeline_arr = json.loads(existing_log.location_timeline_arr or "[]")
    location_log = json.loads(existing_log.location_log_arr)
    location_log['room_name'] = room_name
    location_log['user_patient_name'] = user_or_patient_name
    if location_timeline_arr:
        last_entry = location_timeline_arr[-1]
        last_entry["end_time"] = la_time.isoformat()
        start_time = datetime.fromisoformat(last_entry["start_time"])
        timespan = la_time - start_time
        if timespan > timedelta(seconds=10):
            last_entry['duration'] = str(timespan)
            location_timeline_arr.append(construt_data_new_entry(room_name, user_or_patient_name, la_time))
            existing_log.location_timeline_arr = json.dumps(location_timeline_arr)
            existing_log.location_log_arr = json.dumps(location_log)
            db.session.commit()
def construt_data_new_entry(room_name, user_or_patient_name, la_time):
    la_time = check_time_format(la_time)
    return {
        "room_name": room_name,
        "name": user_or_patient_name,
        "start_time": la_time.isoformat(),
        "end_time": "",
        "duration": ""
    }
def check_time_format(la_time):
    if isinstance(la_time, str):
        la_time = datetime.fromisoformat(la_time)
    return la_time